#!/tvbin/tivosh

# Something I have been forgetting about for a bit over a year now. 
# All locals are stored in a file, and can be listed from the script
# using the "l" command. Shows city and state along with the MarketId
# to help prevent confusion. 
#
# THIS SCRIPT DOES NOT GIVE YOU ANY CHANNELS YOUR CARD IS NOT ALREADY 
# EQUIPPED TO SHOW YOU! IT'S SOLE PURPOSE IS TO GET THE CHANNELS LISTED
# IN THE GUIDE WITHOUT HAVING TO WAIT HOURS FOR NORMAL LOCAL ACTIVATION.
#
# --Juppers


source /tvlib/tcl/tv/mfslib.tcl


proc strim {str} {
    return [string trim $str "\{\}"]
}

proc listMID { } {
    set res "false"
    set tbl [open "./locals.dat" "r"]

    puts "MID, City, State"
    RetryTransaction {
      set match ""
      seek $tbl 0 start
      while { ![eof $tbl] } {
        set expr [gets $tbl] 
        if { $expr == "" } {
          continue
        }
        regexp {([0-9]*),(.*),(.*),([0-9]*),(.*)} $expr found m_mid m_city m_state m_zip m_hex        
        puts "$m_mid, $m_city, $m_state"     
      }
    }
  puts "\n"
  close $tbl
  set res "true"
  return $res;
}


proc listID { } {
    set res "false"
    set mid ""
    set s ""
    set tbl [open "./locals.dat" "r"]
    set db [dbopen]
    
    RetryTransaction {
      set s [db $db open /State/SatConfig]
      set mid [dbobj $s get "MarketId"]
    }
      RetryTransaction {
        set match ""
        seek $tbl 0 start
          while { ![eof $tbl] } {
            set expr [gets $tbl]
            if { [ string match "$mid*" $expr ] } {
              set match $expr
              break
            }
          }

      # No match found
        if { $match == "" } {
          continue
        }

      # Parse match
        regexp {([0-9]*),(.*),(.*),([0-9]*),(.*)} $match found m_mid m_city m_state m_zip m_hex
      puts "\nCurrent MarketId is $mid ($m_city, $m_state.)\n"
      puts "Would you like to Change it? (y/n)"
      gets stdin answer
      if { $answer == "Y" || $answer == "y" } {
        puts "Choose your New MarketId:"
        gets stdin id
          set match ""
          seek $tbl 0 start
            while { ![eof $tbl] } {
              set expr [gets $tbl]
              if { [ string match "$id*" $expr ] } {
                set match $expr
                break
              }
            }

        # No match found
          if { $match == "" } {
            continue
          }

        # Parse match
          regexp {([0-9]*),(.*),(.*),([0-9]*),(.*)} $match found m_mid m_city m_state m_zip m_hex
          puts "\nNew MarketId will be $id ($m_city, $m_state.)\n"
          puts "Are you sure? (y/n)"
          gets stdin answer2
          if { $answer2 == "Y" || $answer2 == "y" } {        
            set s [db $db open /State/SatConfig]
            dbobj $s set MarketId $id
            puts "\nUpdated: MarketId is now $id ($m_city, $m_state.)\n"
            puts "\nFor these channels to stick, your card must be set to localbyte $m_hex and maybe even need a zipcode for that area. A valid zipcode is $m_zip.\n"
        }
      }
    }
    close $tbl
    dbclose $db
    set res "true"
    return res;
}


set done "false"
set id 0

while { $done != "true" } {

    puts "Enter Command (h, l, u, q):"
    gets stdin command
    
    if { $command == "h" || $command == "H" } {
        puts "Usage:"
        puts " h - help"
        puts " l - lists all MarketIds"
        puts " u - list or update current MarketId"
        puts " q - quit"
        continue
    }

    if { $command == "l" || $command == "L" } {
      listMID
      continue
    }

    if { $command == "u" || $command == "U" } {
      listID
      continue
    }

    if { $command == "q" || $command == "Q" } {
        set done "true"
        set db [dbopen]
      RetryTransaction {
        set objSwSystem [db $db open /SwSystem/ACTIVE]
        set objResourceGroup [dbobj $objSwSystem get ResourceGroup]
        set objMpaaRating [lindex $objResourceGroup 0]
        catch { dbobj $objMpaaRating remove CompressedFile }
        puts "\n You must reboot for any changes to take effect."
      }
        dbclose $db
        break
    }

}

